Index: trunk/src/lib/graphics/text_engine/text.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/text.cc	(revision 8527)
+++ trunk/src/lib/graphics/text_engine/text.cc	(revision 8619)
@@ -22,6 +22,4 @@
 #include "debug.h"
 
-using namespace std;
-
 /**
  * @brief creates a new Text Element
@@ -34,8 +32,8 @@
 
   // initialize this Text
-  this->font = NULL;
-  this->size = textSize;
-  this->setSizeY2D(size);
-  this->color = TEXT_DEFAULT_COLOR;
+  this->_font = NULL;
+  this->_size = textSize;
+  this->setSizeY2D(textSize);
+  this->_color = TEXT_DEFAULT_COLOR;
 
   this->setAlignment(TEXT_DEFAULT_ALIGNMENT);
@@ -47,5 +45,5 @@
 {
   this->setClassID(CL_TEXT, "Text");
-  this->font = NULL;
+  this->_font = NULL;
 
   *this = text;
@@ -58,6 +56,6 @@
 Text::~Text()
 {
-  if (this->font != NULL && this->font != Font::getDefaultFont())
-    ResourceManager::getInstance()->unload(this->font);
+  if (this->_font != NULL && this->_font != Font::getDefaultFont())
+    ResourceManager::getInstance()->unload(this->_font);
 }
 
@@ -69,8 +67,8 @@
 bool Text::operator==(const Text& text) const
 {
-  return (this->text == text.text &&
-          this->size == text.size &&
-          this->font == text.font &&
-          this->color == text.color);
+  return (this->_text == text._text &&
+          this->_size == text._size &&
+          this->_font == text._font &&
+          this->_color == text._color);
 }
 
@@ -82,5 +80,5 @@
 bool Text::operator==(const std::string& text) const
 {
-  return (this->text == text);
+  return (this->_text == text);
 }
 
@@ -92,13 +90,13 @@
 Text& Text::operator=(const Text& text)
 {
-  this->size = text.size;
-  this->color = text.color;
+  this->_size = text._size;
+  this->_color = text._color;
   this->setAlignment(text.getAlignment());
-  if (this->font != NULL)
-    ResourceManager::getInstance()->unload(this->font);
-
-  this->font = (Font*)ResourceManager::getInstance()->copy( text.font ); //!< HACK
-
-  this->text = text.text;
+  if (this->_font != NULL)
+    ResourceManager::getInstance()->unload(this->_font);
+
+  this->_font = (Font*)ResourceManager::getInstance()->copy( text._font ); //!< HACK
+
+  this->_text = text._text;
   return *this;
 }
@@ -110,5 +108,5 @@
 void Text::setText(const std::string& text)
 {
-  this->text = text;
+  this->_text = text;
   this->setupTextWidth();
 }
@@ -120,5 +118,5 @@
 void Text::append(const std::string& appendText)
 {
-  this->text += appendText;
+  this->_text += appendText;
   this->setupTextWidth();
 }
@@ -129,5 +127,5 @@
 void Text::appendCharacter(char character)
 {
-  this->text += character;
+  this->_text += character;
   this->setupTextWidth();
 }
@@ -141,5 +139,5 @@
 {
   this->append(appendText);
-  return this->text;
+  return this->_text;
 }
 
@@ -152,8 +150,8 @@
 void Text::removeCharacters(unsigned int chars)
 {
-  if (text.size() > chars)
-    this->text.resize(this->text.size()-chars);
-  else if (!text.empty())
-    text.clear();
+  if (this->_text.size() > chars)
+    this->_text.resize(this->_text.size()-chars);
+  else if (!this->_text.empty())
+    this->_text.clear();
   this->setupTextWidth();
 }
@@ -165,5 +163,5 @@
 void Text::clear()
 {
-  text.clear();
+  this->_text.clear();
   this->setupTextWidth();
 }
@@ -177,5 +175,5 @@
 {
   Font* newFont = NULL;
-  Font* oldFont = this->font;
+  Font* oldFont = this->_font;
 
   // load a new Font
@@ -194,5 +192,5 @@
 
   // unloading the Font if we alrady have one loaded.
-  this->font = newFont;
+  this->_font = newFont;
   if (oldFont != NULL && oldFont != Font::getDefaultFont())
     ResourceManager::getInstance()->unload(oldFont);
@@ -207,5 +205,5 @@
 void Text::setSize(float size)
 {
-  this->size = size;
+  this->_size = size;
   this->setSizeY2D(size);
   this->setupTextWidth();
@@ -218,5 +216,5 @@
 void Text::draw() const
 {
-  if (unlikely(this->text.empty()))
+  if (unlikely(this->_text.empty()))
     return;
   glPushMatrix();
@@ -230,5 +228,5 @@
   // drawing this Text.
   // setting the Blending effects
-  glColor4fv(&this->color[0]);
+  glColor4fv(&this->_color[0]);
 
 
@@ -240,5 +238,5 @@
   glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, GL_MODULATE );
 
-  glBindTexture(GL_TEXTURE_2D, font->getTexture());
+  glBindTexture(GL_TEXTURE_2D, this->_font->getTexture());
   glTranslatef(getAbsCoor2D().x, getAbsCoor2D().y, 0);
   glRotatef(this->getAbsDir2D(), 0, 0, 1);
@@ -247,21 +245,21 @@
   float posX = 0.0f;
   glBegin(GL_QUADS);
-  for (unsigned int i = 0; i < this->text.size(); i++)
+  for (unsigned int i = 0; i < this->_text.size(); i++)
   {
-    if(likely((tmpGlyph = this->getFont()->getGlyphArray()[this->text[i]]) != NULL))
+    if(likely((tmpGlyph = this->font()->getGlyphArray()[this->_text[i]]) != NULL))
     {
       glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[2]);
-      glVertex2d(posX+tmpGlyph->maxX*this->getSize(), 0);
+      glVertex2d(posX+tmpGlyph->maxX*this->size(), 0);
 
       glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[3]);
-      glVertex2d(posX+tmpGlyph->maxX*this->getSize(), this->getSize());
+      glVertex2d(posX+tmpGlyph->maxX*this->size(), this->size());
 
       glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[3]);
-      glVertex2d(posX+tmpGlyph->minX*this->getSize(), this->getSize());
+      glVertex2d(posX+tmpGlyph->minX*this->size(), this->size());
 
       glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[2]);
-      glVertex2d(posX+tmpGlyph->minX*this->getSize(), 0);
-
-      posX += tmpGlyph->advance * this->getSize();
+      glVertex2d(posX+tmpGlyph->minX*this->size(), 0);
+
+      posX += tmpGlyph->advance * this->size();
     }
   }
@@ -278,8 +276,8 @@
 {
   float width = 0;
-  for (unsigned int i = 0; i < this->text.size(); i++)
-    if(this->font->getGlyphArray()[this->text[i]] != NULL)
-      width += this->font->getGlyphArray()[this->text[i]]->advance;
-  this->setSizeX2D(width * this->getSize());
+  for (unsigned int i = 0; i < this->_text.size(); i++)
+    if(this->_font->getGlyphArray()[this->_text[i]] != NULL)
+      width += this->_font->getGlyphArray()[this->_text[i]]->advance;
+  this->setSizeX2D(width * this->size());
 }
 
@@ -290,6 +288,6 @@
 void Text::debug() const
 {
-  PRINT(0)("=== TEXT: %s (with Font:'%s')  displaying %s ===\n", this->getName(), this->font->getName(), this->text.c_str());
-  PRINT(0)("Color: r=%0.2f g=%0.2f b=%0.2f a=%0.2f\n", this->color.r(), this->color.g(), this->color.b(), this->color.a());
-}
-
+  PRINT(0)("=== TEXT: %s (with Font:'%s')  displaying %s ===\n", this->getName(), this->_font->getName(), this->_text.c_str());
+  PRINT(0)("Color: r=%0.2f g=%0.2f b=%0.2f a=%0.2f\n", this->_color.r(), this->_color.g(), this->_color.b(), this->_color.a());
+}
+
Index: trunk/src/lib/graphics/text_engine/text.h
===================================================================
--- trunk/src/lib/graphics/text_engine/text.h	(revision 8527)
+++ trunk/src/lib/graphics/text_engine/text.h	(revision 8619)
@@ -45,9 +45,9 @@
     void setFont(const std::string& fontFile, unsigned int renderSize);
     /** @param blending the blending intensity to set (between 0.0 and 1.0) */
-    inline void setBlending(float blending) { this->color.a() = blending; };
+    inline void setBlending(float blending) { this->_color.a() = blending; };
     /** @param r red @param g green @param b blue @brief sets the Color of the Text to render (values in [0-1]) */
-    void setColor(float r, float g, float b) { this->color = Color(r, g, b, this->color.a()); };
-    void setColor(float r, float g, float b, float a) { this->color = Color(r, g, b, a); };
-    void setColor(const Color& color) { this->color = color; };
+    void setColor(float r, float g, float b) { this->_color = Color(r, g, b, this->_color.a()); };
+    void setColor(float r, float g, float b, float a) { this->_color = Color(r, g, b, a); };
+    void setColor(const Color& color) { this->_color = color; };
     void setSize(float size);
 
@@ -55,14 +55,14 @@
     /// RETRIEVE
     /** @returns the String this Text displays */
-    inline const std::string& getText() const { return this->text; };
+    inline const std::string& text() const { return this->_text; };
 
     /** @returns the pointer to the stored Font (not changeable) */
-    inline const Font* const getFont() const { return this->font; };
+    inline const Font* const font() const { return this->_font; };
     /** @returns the Blending Value [0 invisible 1.0 full visible */
-    inline float getBlending() const { return this->color.a(); };
+    inline float blending() const { return this->_color.a(); };
     /** @returns: a Vector(r,g,b) @brief: retrieve a Vector holding the Color of the Text */
-    inline const Color& getColor() const { return this->color; };
+    inline const Color& color() const { return this->_color; };
     /** @returns the Size of the Text */
-    inline float getSize() const { return this->size; };
+    inline float size() const { return this->_size; };
 
     virtual void draw() const;
@@ -76,9 +76,9 @@
 
   private:
-    Font*             font;           //!< Font of this text
+    Font*             _font;           //!< Font of this text
 
-    std::string       text;           //!< The text to display
-    Color             color;          //!< The color of the font.
-    float             size;           //!< The size of the Text.
+    std::string       _text;           //!< The text to display
+    Color             _color;          //!< The color of the font.
+    float             _size;           //!< The size of the Text.
 };
 
Index: trunk/src/lib/gui/gl/Makefile.am
===================================================================
--- trunk/src/lib/gui/gl/Makefile.am	(revision 8527)
+++ trunk/src/lib/gui/gl/Makefile.am	(revision 8619)
@@ -12,5 +12,4 @@
 		glmenu/glmenu_imagescreen.cc \
 		\
-		glgui_style.cc \
 		glgui_handler.cc \
 		signal_connector.cc \
@@ -27,4 +26,5 @@
 		glgui_inputline.cc \
 		glgui_textfield.cc \
+		glgui_table.cc \
 		glgui_image.cc \
 		glgui_window.cc \
@@ -37,5 +37,4 @@
 		glmenu/glmenu_imagescreen.h \
 		\
-		glgui_style.h \
 		signal_connector.h \
 		glgui.h \
@@ -54,4 +53,5 @@
 		glgui_inputline.h \
 		glgui_textfield.h \
+		glgui_table.h \
 		glgui_image.h \
 		glgui_window.h \
Index: trunk/src/lib/gui/gl/glgui.h
===================================================================
--- trunk/src/lib/gui/gl/glgui.h	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui.h	(revision 8619)
@@ -16,5 +16,4 @@
 #include "glgui_button.h"
 #include "glgui_checkbutton.h"
-//#include "glgui_colorselector.h"
 #include "glgui_pushbutton.h"
 #include "glgui_slider.h"
@@ -22,4 +21,5 @@
 #include "glgui_inputline.h"
 #include "glgui_textfield.h"
+#include "glgui_table.h"
 #include "glgui_image.h"
 
Index: trunk/src/lib/gui/gl/glgui_box.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_box.cc	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_box.cc	(revision 8619)
@@ -110,5 +110,5 @@
     if (orientation() == OrxGui::Vertical)
     {
-      float height = this->borderTop();
+      float height = borderTop();
       float width = 0.0f;
       std::vector<GLGuiWidget*>::iterator widget;
@@ -117,11 +117,11 @@
       for (widget = this->children.begin(); widget != this->children.end(); ++widget)
       {
-        (*widget)->setRelCoor2D(this->borderLeft(), height);
+        (*widget)->setRelCoor2D(borderLeft(), height);
         height += (*widget)->getSizeY2D();
         width = fmax(width, (*widget)->getSizeX2D());
       }
 
-      width += this->borderLeft() + this->borderRight();
-      height += this->borderBottom(); /* *2 done further up */
+      width += borderLeft() + borderRight();
+      height += borderBottom(); /* *2 done further up */
 
       printf("%f %f\n", width, height);
@@ -130,6 +130,6 @@
     else
     {
-      float height = this->borderTop();
-      float width = this->borderLeft();
+      float height = borderTop();
+      float width = borderLeft();
       std::vector<GLGuiWidget*>::iterator widget;
 
@@ -137,11 +137,11 @@
       for (widget = this->children.begin(); widget != this->children.end(); ++widget)
       {
-        (*widget)->setRelCoor2D(width, this->borderTop());
+        (*widget)->setRelCoor2D(width, borderTop());
         height = fmax(height, (*widget)->getSizeY2D());
         width += (*widget)->getSizeX2D();
       }
 
-      width += this->borderRight() ;
-      height += this->borderBottom(); /* *2 done further up */
+      width += borderRight() ;
+      height += borderBottom(); /* *2 done further up */
 
       printf("%f %f\n", width, height);
Index: trunk/src/lib/gui/gl/glgui_button.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_button.cc	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_button.cc	(revision 8619)
@@ -55,5 +55,5 @@
 
     this->_label.setFont("fonts/final_frontier.ttf", 20);
-    this->_label.setColor(this->frontColor());
+    this->_label.setColor(this->foregroundColor() );
 
     this->_label.setParent2D(this);
@@ -71,5 +71,5 @@
   void GLGuiButton::updateFrontColor()
   {
-    this->_label.setColor(this->frontColor());
+    this->_label.setColor(this->foregroundColor());
   }
 
Index: trunk/src/lib/gui/gl/glgui_button.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_button.h	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_button.h	(revision 8619)
@@ -36,5 +36,5 @@
       virtual ~GLGuiButton();
 
-      const std::string& label() const { return this->_label.getText(); };
+      const std::string& label() const { return this->_label.text(); };
       void setLabel(const std::string& label);
 
Index: trunk/src/lib/gui/gl/glgui_checkbutton.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_checkbutton.cc	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_checkbutton.cc	(revision 8619)
@@ -96,8 +96,7 @@
 //     this->frontMaterial().select();
 //     this->drawRect(this->frontRect());
-
     if (this->bActive)
     {
-      glColor3fv( &this->frontColor()[0]);
+      glColor3fv( &this->foregroundColor()[0]);
       this->drawRect(this->_checkBox);
 
@@ -124,5 +123,5 @@
     else
     {
-      glColor3fv( &this->frontColor()[0]);
+      glColor3fv( &this->foregroundColor()[0]);
       this->drawRect(this->_checkBox);
     }
Index: trunk/src/lib/gui/gl/glgui_container.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_container.cc	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_container.cc	(revision 8619)
@@ -43,4 +43,6 @@
     this->setClassID(CL_GLGUI_CONTAINER, "GLGuiContainer");
 
+    this->setBackgroundTexture("gui_container_background.png");
+
   }
 
Index: trunk/src/lib/gui/gl/glgui_cursor.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_cursor.cc	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_cursor.cc	(revision 8619)
@@ -57,11 +57,11 @@
     this->setClassID(CL_GLGUI_CURSOR, "GLGuiCursor");
 
-    this->backMaterial().setDiffuse(1.0,0.0,0.0);
-    this->backMaterial().setDiffuseMap("cursor.png");
-    this->backMaterial().setBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+    this->setBackgroundColor(Color(1.0, 1.0, 1.0, 1.0));
+    this->setBackgroundTexture("cursor.png");
     this->setSize2D(50, 50);
     this->setAbsCoor2D(100, 100);
     this->setLayer(E2D_LAYER_ABOVE_ALL);
     this->color = 0.0f;
+    this->frameNumber = 0.0f;
 
     this->resize();
@@ -79,5 +79,5 @@
   bool GLGuiCursor::loadTextureSequence(const std::string& imageNameSubstitue, unsigned int from, unsigned int to)
   {
-    this->backMaterial().setDiffuse(1.0, 1.0, 1.0);
+    //this->background().setDiffuse(1.0, 1.0, 1.0);
     return this->seq.loadImageSeries(imageNameSubstitue, from, to);
   }
@@ -97,5 +97,7 @@
         this->color -= 360.0;
       Vector color =  Color::HSVtoRGB(Vector(this->color, 1.0, 1.0));
-      this->backMaterial().setDiffuse(color.x, color.y, color.z);
+      //this->setBackgroundColor(color.x, color.y, color.z);
+      /// FIXME
+
     }
     //if (this->movement != Vector2D())
@@ -125,5 +127,5 @@
     this->beginDraw();
 
-    this->backMaterial().select();
+    this->background().select();
     if (!this->seq.empty())
       glBindTexture(GL_TEXTURE_2D, this->seq.getFrameTexture((int)frameNumber));
Index: trunk/src/lib/gui/gl/glgui_defs.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_defs.h	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_defs.h	(revision 8619)
@@ -22,4 +22,5 @@
   } Orientation;
 
+  //! Names of Orientations
   const std::string OrientationString[] = {
     "Horizontal",
@@ -30,5 +31,5 @@
   typedef enum {
     Normal,           //!< Normal state of the GUI's Widgets.
-    Active,           //!< If the widget is Active.
+    Focused,           //!< If the widget is Active.
     Selected,         //!< If the Widget is Selected.
     Insensitive       //!< If the Widget is insensitive.
@@ -38,8 +39,9 @@
 #define GLGUI_DEFAULT_STYLE OrxGui::Normal
 
+//! names of the States.
   const std::string StateString[] =
     {
       "Normal",
-      "Active",
+      "Focused",
       "Selected",
       "Insensitive"
@@ -54,4 +56,5 @@
     } FeaturePosition;
 
+    //! Names of Feature-Positions
     const std::string FeaturePositionString[] =
     {
Index: trunk/src/lib/gui/gl/glgui_image.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_image.cc	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_image.cc	(revision 8619)
@@ -47,4 +47,5 @@
     this->setClassID(CL_GLGUI_IMAGE, "GLGuiImage");
 
+    this->setForegroundColor(Color(1,1,1,1));
     this->_imageMaterial.setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 
@@ -76,10 +77,10 @@
   void GLGuiImage::updateFrontColor()
   {
-    this->_imageMaterial.setDiffuseColor(this->frontColor());
+    this->_imageMaterial.setDiffuseColor(foregroundColor());
   }
 
   void GLGuiImage::resize()
   {
-    this->_imagePlane.setTopLeft(this->borderLeft(), this->borderTop());
+    this->_imagePlane.setTopLeft(borderLeft(), borderTop());
     this->_imagePlane.setSize(this->getSizeX2D() - (borderLeft() + borderRight()), this->getSizeY2D() - (borderTop() + borderBottom()) );
     GLGuiWidget::resize();
Index: trunk/src/lib/gui/gl/glgui_inputline.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_inputline.cc	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_inputline.cc	(revision 8619)
@@ -52,7 +52,13 @@
     this->_text.setRelCoor2D(4,4);
     this->_text.setFont("fonts/final_frontier.ttf", 20);
-    this->_text.setColor(this->frontColor());
+    this->_text.setLineWidth(400);
+    this->_text.setDotsPosition(LimitedWidthText::Begin);
+    this->_text.setColor(foregroundColor());
     this->_text.setVisibility(false);
     this->resize();
+
+    this->delayNext = 0.0;
+    this->pressedKey = SDLK_FIRST;
+    this->pressedKeyName = SDLK_FIRST;
 
   }
@@ -116,6 +122,5 @@
     this->resize();
     this->setFrontColor(Color(1,1,1,1), true);
-    this->setFrontColor(Color(0,1,0,1));
-    emit(this->textChanged(this->_text.getText()));
+    emit(this->textChanged(this->_text.text()));
   }
 
@@ -139,5 +144,5 @@
   void GLGuiInputLine::pushEnter()
   {
-    emit(this->enterPushed(this->_text.getText()));
+    emit(this->enterPushed(this->_text.text()));
     if (this->_clearOnEnter)
       this->clear();
@@ -197,14 +202,14 @@
   void GLGuiInputLine::resize()
   {
-    this->_text.setRelCoor2D(this->borderLeft(), this->borderTop());
+    this->_text.setRelCoor2D(borderLeft(), borderTop());
     this->setSize2D( this->_text.getSize2D() + Vector2D(borderLeft() + borderRight(), borderTop() + borderBottom()));
     GLGuiWidget::resize();
-/*    this->frontRect().setTopLeft(borderLeft(), borderTop());
-    this->frontRect().setSize(this->getSize2D() - Vector2D(borderLeft() + borderRight(), borderTop() + borderBottom()));*/
+    /*    this->frontRect().setTopLeft(borderLeft(), borderTop());
+        this->frontRect().setSize(this->getSize2D() - Vector2D(borderLeft() + borderRight(), borderTop() + borderBottom()));*/
   }
 
   void GLGuiInputLine::updateFrontColor()
   {
-    this->_text.setColor(this->frontColor());
+    this->_text.setColor(foregroundColor());
   }
 
@@ -228,5 +233,5 @@
     if (this->delayNext > 0.0)
       this->delayNext -= dt;
-        else if (this->pressedKey != SDLK_FIRST )
+    else if (this->pressedKey != SDLK_FIRST )
     {
       this->delayNext = GLGuiInputLine::repeatRate;
@@ -237,8 +242,8 @@
           break;
         default:
-        {
-          if (likely(this->pressedKey < 127))
-            this->appendCharacter(this->pressedKeyName);
-        }
+          {
+            if (likely(this->pressedKey < 127))
+              this->appendCharacter(this->pressedKeyName);
+          }
       }
     }
@@ -255,6 +260,6 @@
     GLGuiWidget::draw();
 
-//     this->frontMaterial().select();
-//     GLGuiWidget::drawRect(this->frontRect());
+    //     this->frontMaterial().select();
+    //     GLGuiWidget::drawRect(this->frontRect());
 
     this->endDraw();
Index: trunk/src/lib/gui/gl/glgui_inputline.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_inputline.h	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_inputline.h	(revision 8619)
@@ -9,5 +9,5 @@
 
 #include "glgui_widget.h"
-#include "text.h"
+#include "limited_width_text.h"
 #include "event.h"
 
@@ -32,5 +32,5 @@
 
     /** @returns the text of the inputLine */
-    const std::string& _getText() const { return this->_text.getText(); };
+    const std::string& _getText() const { return this->_text.text(); };
 
     void setText(const std::string& text);
@@ -66,5 +66,5 @@
 
   private:
-    Text                    _text;            //!< The Text to display inside of the InputLine.
+    LimitedWidthText        _text;            //!< The Text to display inside of the InputLine.
     bool                    _clearOnEnter;    //!< Clear on Enter
 
Index: trunk/src/lib/gui/gl/glgui_slider.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_slider.cc	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_slider.cc	(revision 8619)
@@ -74,5 +74,5 @@
     else
       this->_value = value;
-    this->_handle.setCenter(this->sliderPosition(), this->borderTop() + (this->getSizeY2D() - this->borderTop() - borderBottom()) / 2.0);
+    this->_handle.setCenter(this->sliderPosition(), borderTop() + (this->getSizeY2D() - borderTop() - borderBottom()) / 2.0);
 
     emit(valueChanged(this->_value));
@@ -165,5 +165,5 @@
 //    this->frontRect().setTopLeft(this->borderLeft(), this->getSizeY2D()/2.0 - 2.0);
 //    this->frontRect().setSize(this->getSizeX2D() - borderLeft() - borderRight(), 4.0);
-    this->_slider.setTopLeft(this->borderLeft(), this->getSizeY2D() / 2.0 -2.0);
+    this->_slider.setTopLeft(borderLeft(), this->getSizeY2D() / 2.0 -2.0);
     this->_slider.setSize(this->getSizeX2D() - borderLeft() - borderRight(), 4.0);
     this->_handle.setSize(this->_sliderWidth, this->getSizeY2D() - borderTop() - borderBottom());
@@ -211,6 +211,6 @@
   {
     return (this->_value - this->_minValue)/( this->_maxValue - this->_minValue) *
-           (this->getSizeX2D() - (borderLeft() + borderRight() + 2.0*_sliderWidth)) +
-           (borderLeft() +_sliderWidth);
+        (this->getSizeX2D() - (borderLeft() + borderRight() + 2.0*_sliderWidth)) +
+        (borderLeft() +_sliderWidth);
   }
 
@@ -239,5 +239,5 @@
     GLGuiWidget::draw();
 
-    glColor4fv(&this->frontColor()[0]);
+    glColor4fv(&this->foregroundColor()[0]);
     this->drawRect(this->_slider);
     this->drawRect(this->_handle);
Index: trunk/src/lib/gui/gl/glgui_table.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_table.cc	(revision 8619)
+++ trunk/src/lib/gui/gl/glgui_table.cc	(revision 8619)
@@ -0,0 +1,266 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GUI
+
+#include "glgui_table.h"
+#include "debug.h"
+
+namespace OrxGui
+{
+  /**
+   * @brief standard constructor
+   */
+  GLGuiTable::GLGuiTable (unsigned int rows, unsigned int columns)
+  {
+    this->init();
+    this->setRowCount(rows);
+    this->setColumnCount(columns);
+  }
+
+
+  /**
+   * @brief standard deconstructor
+   */
+  GLGuiTable::~GLGuiTable()
+  {}
+
+  /**
+   * @brief initializes the GUI-element
+   */
+  void GLGuiTable::init()
+  {
+    this->setClassID(CL_GLGUI_TABLE, "GLGuiTable");
+
+    this->setFocusable(true);
+    this->setClickable(true);
+
+    this->resize();
+  }
+
+
+  void GLGuiTable::setRowCount(unsigned int rowCount)
+  {
+
+    unsigned int currentRowCount = this->rowCount();
+    this->_entries.resize(rowCount);
+    for (unsigned int i = currentRowCount; i < this->rowCount(); ++i)
+    {
+      this->_entries[i].resize(columnCount(), LimitedWidthText("fonts/final_frontier.ttf", 20));
+      for (unsigned int j = 0; j < columnCount(); ++j)
+        this->applyTextSettings(i, j, &this->_entries[i][j]);
+    }
+
+    assert(this->checkIntegrity());
+    this->debug();
+
+    if (!this->isVisible())
+      this->hiding();
+  }
+
+  void GLGuiTable::setColumnCount(unsigned int columnCount)
+  {
+    unsigned int i;
+    unsigned int currentColumnCount = this->columnCount();
+
+    // setup Headers.
+    this->_headers.resize(columnCount, LimitedWidthText("fonts/final_frontier.ttf", 20));
+    for (i = currentColumnCount; i < columnCount; ++i)
+      this->applyTextSettings(0, i, &this->_headers[i]);
+
+    for (i = 0; i < rowCount(); i++)
+    {
+      this->_entries[i].resize(columnCount, LimitedWidthText("fonts/final_frontier.ttf", 20));
+      for (unsigned int j = currentColumnCount; j < columnCount; ++j)
+        this->applyTextSettings(i, j, &this->_entries[i][j]);
+
+    }
+    assert(this->checkIntegrity());
+    this->debug();
+
+    if (!this->isVisible())
+      this->hiding();
+  }
+
+
+
+
+  void GLGuiTable::setHeader(unsigned int number, const std::string& headerName)
+  {
+    if (number >= this->columnCount())
+      this->setColumnCount(number + 1);
+    this->_headers[number].setText(headerName);
+  }
+
+  void GLGuiTable::setHeader(const std::vector<std::string>& headerNames)
+  {
+    for (unsigned int i = 0; i < headerNames.size(); ++i)
+      this->setHeader(i, headerNames[i]);
+  }
+
+  void GLGuiTable::setEntry(unsigned int column, unsigned int row, const std::string& name)
+  {
+    if (column >= this->columnCount() )
+      this->setColumnCount(column + 1);
+    if (row >= this->rowCount() )
+      this->setRowCount(row + 1);
+    this->_entries[row][column].setText(name);
+  }
+
+  void GLGuiTable::setColumnWidth(unsigned int column, float size)
+  {
+    this->_headers[column].setLineWidth(size);
+    for (unsigned int i = 0; i < this->rowCount(); ++i)
+      this->_entries[i][column].setLineWidth(size);
+
+  }
+
+  /// TODO.
+  void GLGuiTable::setRowHeight(unsigned int row, unsigned int size)
+{}
+
+
+
+
+  /**
+   * removes the focus from this Widget.
+   */
+  void GLGuiTable::removedFocus()
+  {
+    GLGuiWidget::removedFocus();
+  }
+
+
+
+  /**
+   * @brief Processes an Event.
+   * @param event The event to be processed
+   * @return true if the event was catched.
+   */
+  bool GLGuiTable::processEvent(const Event& event)
+  {
+    return false;
+  }
+
+
+  /**
+   * @brief Resizes the Widget to the new Size-constraints.
+   */
+  void GLGuiTable::resize()
+  {
+    GLGuiWidget::resize();
+  }
+
+  void GLGuiTable::updateFrontColor()
+  {
+    for (unsigned int i = 0; i < this->columnCount(); ++i)
+    {
+      this->_headers[i].setColor(this->foregroundColor());
+      for (unsigned int j = 0; j < this->rowCount(); ++j)
+        this->_entries[j][i].setColor(this->foregroundColor());
+    }
+  }
+
+  void GLGuiTable::hiding()
+  {
+    for (unsigned int i = 0; i < this->columnCount(); ++i)
+    {
+      this->_headers[i].setVisibility(false);
+      for (unsigned int j = 0; j < this->rowCount(); ++j)
+        this->_entries[j][i].setVisibility(false);
+    }
+  }
+
+  void GLGuiTable::showing()
+  {
+    for (unsigned int i = 0; i < this->columnCount(); ++i)
+    {
+      this->_headers[i].setVisibility(true);
+      for (unsigned int j = 0; j < this->rowCount(); ++j)
+        this->_entries[j][i].setVisibility(true);
+    }
+  }
+
+
+  /**
+   * @brief ticks the Table
+   * @param dt the time passed.
+   */
+  void GLGuiTable::tick(float dt)
+{}
+
+  /**
+   * @brief draws the GLGuiTable
+   */
+  void GLGuiTable::draw() const
+  {
+    this->beginDraw();
+    GLGuiWidget::draw();
+
+    //     this->frontMaterial().select();
+    //     GLGuiWidget::drawRect(this->frontRect());
+
+    this->endDraw();
+  }
+
+
+  /**
+   * @brief applies the GLGuiNotifiers Settings to a single Text of the GLGuiNotifier.
+   * @param text the Text to apply the settings to.
+   */
+  void GLGuiTable::applyTextSettings(unsigned int row, unsigned int column, LimitedWidthText* text)
+  {
+    text->setSize(this->textSize());
+    //text->setLineWidth(  );
+    text->setFont("fonts/final_frontier.ttf", (int)this->textSize());
+
+    text->setColor(this->foregroundColor());
+    if (text->getParent2D() != this)
+      text->setParent2D(this);
+  }
+
+
+  void GLGuiTable::debug() const
+  {
+    PRINT(0)("Table: Size = %dx%d\n", this->rowCount(), this->columnCount());
+
+    for (unsigned int i = 0; i < this->rowCount(); ++i)
+      PRINT(0)("line %d: columns %d\n", i, this->_entries[i].size());
+  }
+
+
+  bool GLGuiTable::checkIntegrity() const
+  {
+    bool retVal = true;
+    if (rowCount() != this->_entries.size())
+    {
+      PRINTF(1)("ROW COUNT WRONG (is %d should be %d)\n", rowCount(), this->_entries.size());
+      retVal = false;
+    }
+    if (columnCount() != this->_headers.size())
+    {
+      PRINTF(1)("COLUMN COUNT WRONG (is %d should be %d)\n", columnCount(), this->_headers.size());
+      retVal = false;
+    }
+    for (unsigned int i = 0; i < this->rowCount(); ++i)
+      if (this->_entries[i].size() != this->columnCount())
+    {
+      PRINTF(1)("COLUMN-COUNT OF ROW %d WRONG (is %d should be %d)\n", i, this->_entries[i].size(), this->columnCount());
+      retVal = false;
+    }
+    return retVal;
+  }
+
+}
